package com.kingdee.eas.custom.notify.app;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectValue;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.notify.NotifyTodoInfo;
import com.kingdee.eas.custom.notify.RemoveContextInfo;
import com.kingdee.eas.custom.notify.SendContextInfo;
import com.kingdee.eas.custom.notify.UpdateContentInfo;
import com.kingdee.eas.custom.notify.notifyTodo.*;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;

import java.io.*;
import java.lang.Exception;
import java.net.URL;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;


public class NotifyTodoControllerBean extends AbstractNotifyTodoControllerBean {
    private static Logger logger = Logger.getLogger(NotifyTodoControllerBean.class);
    private static Map maps = new HashMap();

    static {
        loadConfig();
    }

    /**
     * 
     */
    public static void loadConfig() {
        Properties props = new Properties();
        try {
            String propertiesUrl = System.getProperty("EAS_HOME") + "/server/properties/notifyTodo/propertie.properties";
            logger.debug("propertiesUrl:" + propertiesUrl);
            InputStream InputStream = new BufferedInputStream(new FileInputStream(new File(propertiesUrl)));
            props.load(InputStream);
        } catch (IOException var4) {
            var4.printStackTrace();
            logger.error("켯ɻȡļ: " + var4.getMessage());
        }
        Enumeration en = props.propertyNames();
        while (en.hasMoreElements()) {
            String key = (String) en.nextElement();
            String value = props.getProperty(key);
            maps.put(key, value);
            logger.debug(key + " : " + value);
        }
    }

    /**
     * ȡ
     *
     * @param key
     * @return
     */
    public static String getConfigValue(String key) {
        return (String) maps.get(key);
    }


    /**
     * ɾ
     *
     * @param ctx
     * @throws BOSException
     */
    @Override
    protected void _deleteTodo(Context ctx, IObjectValue content)
            throws BOSException, EASBizException {
        String portAddress = getConfigValue("portAddress");
        if (StringUtils.isEmpty(portAddress)) {
            throw new BOSException("ɾӿڵַΪգļ/server/properties/notifyTodo/propertie.propertiesǷάportAddressԪ");
        }
        try {
            ISysNotifyTodoWebServiceServiceLocator iSysNotifyTodoWebServiceServiceLocator = new ISysNotifyTodoWebServiceServiceLocator();
            URL url = new URL(portAddress);
            ISysNotifyTodoWebService iSysNotifyTodoWebServicePort = iSysNotifyTodoWebServiceServiceLocator.getISysNotifyTodoWebServicePort(url);
            NotifyTodoRemoveContext removeContext = new NotifyTodoRemoveContext((RemoveContextInfo) content);
            //ɾ
            NotifyTodoAppResult notifyTodoAppResult = iSysNotifyTodoWebServicePort.deleteTodo(removeContext);

        } catch (Exception e) {
            e.printStackTrace();
            logger.error(e.getMessage());
            throw new BOSException(e);
        }
    }

    /**
     * ´
     *
     * @param ctx
     * @throws BOSException
     */
    @Override
    protected void _updateTodo(Context ctx, IObjectValue content) throws BOSException {
        String portAddress = getConfigValue("portAddress");
        if (StringUtils.isEmpty(portAddress)) {
            throw new BOSException("´ӿڵַΪգļ/server/properties/notifyTodo/propertie.propertiesǷάportAddressԪ");
        }
        try {
            ISysNotifyTodoWebServiceServiceLocator iSysNotifyTodoWebServiceServiceLocator = new ISysNotifyTodoWebServiceServiceLocator();
            URL url = new URL(portAddress);
            ISysNotifyTodoWebService iSysNotifyTodoWebServicePort = iSysNotifyTodoWebServiceServiceLocator.getISysNotifyTodoWebServicePort(url);
            NotifyTodoUpdateContext context = new NotifyTodoUpdateContext((UpdateContentInfo) content);
            //´
            NotifyTodoAppResult notifyTodoAppResult = iSysNotifyTodoWebServicePort.updateTodo(context);
        } catch (Exception e) {
            e.printStackTrace();
            logger.error(e.getMessage());
            throw new BOSException(e);
        }
    }

    /**
     * ΪѰ
     *
     * @param ctx
     * @throws BOSException
     */
    @Override
    protected void _setTodoDone(Context ctx, IObjectValue content) throws BOSException {
        String portAddress = getConfigValue("portAddress");
        if (StringUtils.isEmpty(portAddress)) {
            throw new BOSException("ΪѰӿڵַΪգļ/server/properties/notifyTodo/propertie.propertiesǷάportAddressԪ");
        }
        try {
            ISysNotifyTodoWebServiceServiceLocator iSysNotifyTodoWebServiceServiceLocator = new ISysNotifyTodoWebServiceServiceLocator();
            URL url = new URL(portAddress);
            ISysNotifyTodoWebService iSysNotifyTodoWebServicePort = iSysNotifyTodoWebServiceServiceLocator.getISysNotifyTodoWebServicePort(url);
            NotifyTodoRemoveContext context = new NotifyTodoRemoveContext((RemoveContextInfo) content);
            //ΪѰ
            NotifyTodoAppResult notifyTodoAppResult = iSysNotifyTodoWebServicePort.setTodoDone(context);
        } catch (Exception e) {
            e.printStackTrace();
            logger.error(e.getMessage());
            throw new BOSException(e);
        }
    }

    /**
     * ʹ
     *
     * @param ctx
     * @throws BOSException
     */
    @Override
    protected void _sendTodo(Context ctx, IObjectValue content) throws BOSException {
        String portAddress = getConfigValue("portAddress");
        if (StringUtils.isEmpty(portAddress)) {
            throw new BOSException("ʹӿڵַΪգļ/server/properties/notifyTodo/propertie.propertiesǷάportAddressԪ");
        }
        NotifyTodoAppResult result = null;
        try {
            ISysNotifyTodoWebServiceServiceLocator iSysNotifyTodoWebServiceServiceLocator = new ISysNotifyTodoWebServiceServiceLocator();
            URL url = new URL(portAddress);
            ISysNotifyTodoWebService iSysNotifyTodoWebServicePort = iSysNotifyTodoWebServiceServiceLocator.getISysNotifyTodoWebServicePort(url);
            NotifyTodoSendContext context = new NotifyTodoSendContext((SendContextInfo) content);
            //ʹ
            result = iSysNotifyTodoWebServicePort.sendTodo(context);
            if (result.getReturnState() == 1) {
                String message = result.getMessage();
            } else {
                throw new BOSException("");
            }
            NotifyTodoInfo info = new NotifyTodoInfo();
            save(ctx, info);
        } catch (Exception e) {
            e.printStackTrace();
            logger.error(e.getMessage());
            throw new BOSException(e);
        }
    }
}