package com.kingdee.eas.custom.performancenew.handler;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.ctrl.swing.StringUtils;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.bos.sql.ParserException;
import com.kingdee.eas.basedata.org.AdminOrgUnitFactory;
import com.kingdee.eas.basedata.org.AdminOrgUnitInfo;
import com.kingdee.eas.basedata.org.IAdminOrgUnit;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.performancenew.*;
import com.kingdee.eas.custom.performancenew.app.orderStatucEnum;
import com.kingdee.eas.custom.performancenew.app.periodTypeEnum;
import com.kingdee.eas.custom.performancenew.app.scoreEnum;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.util.app.ContextUtil;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.web.handler.EditHandler;
import com.kingdee.shr.base.syssetting.web.json.JSONUtils;
import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.text.DecimalFormat;
import java.util.*;

/**
 * @author qingwu
 * @date 2024/4/11
 * @apiNote ڼ  ͨ
 */
public class ExamineScorerEditHandler extends EditHandler {
    private Context ctx = SHRContext.getInstance().getContext();
    private  Logger logger =
            Logger.getLogger(ExamineScorerEditHandler.class);

    /**
     * ύ
     *
     * @param request
     * @param response
     * @param modelMap
     * @return
     */
    public void customSubmitAction(HttpServletRequest request,
                                   HttpServletResponse response,
                                   ModelMap modelMap) throws BOSException, ParserException, ShrWebBizException {
        String billID = request.getParameter("billId");
        //id
        String adminIdArray = request.getParameter("adminIdArray");
        if (com.kingdee.util.StringUtils.isEmpty(billID) && com.kingdee.util.StringUtils.isEmpty(adminIdArray)) {
            throw new BOSException("idѡŲΪգ");
        }
        try {
            //ü÷
            calculateScoreAction(request, response, modelMap);

            IExamineGradePersonEntry iExamineGradePersonEntry = ExamineGradePersonEntryFactory.getLocalInstance(ctx);
            String[] split = adminIdArray.split(",");
            SelectorItemCollection sic = new SelectorItemCollection();
            sic.add("orderStatuc");
            Map isSortedMap = null;
            for (int i = 0; i < split.length; i++) {
                String adminId = split[i];
                ExamineGradePersonEntryCollection entryColl = getCurrentPersonEqualsScore(billID, adminId);
                for (int j = 0; j < entryColl.size(); j++) {
                    ExamineGradePersonEntryInfo entryInfo = entryColl.get(j);
                    entryInfo.setOrderStatuc(orderStatucEnum.submitted);
                    iExamineGradePersonEntry.updatePartial(entryInfo, sic);
                }
            }
            JSONUtils.SUCCESS(isSortedMap);
        } catch (Exception e) {
            e.printStackTrace();
            throw new ShrWebBizException(e);
        }


    }

    /**
     * ÷
     *
     * @param request
     * @param response
     * @param modelMap
     * @throws BOSException
     */
    public void calculateScoreAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws BOSException {
        String billID = request.getParameter("billId");
        if (StringUtils.isEmpty(billID)) {
            throw new BOSException("idΪգ");
        }
        //id
        String adminIdArray = request.getParameter("adminIdArray");
        try {
            IExamineGradePersonEntry iExamineGradePersonEntry = ExamineGradePersonEntryFactory.getLocalInstance(ctx);
            String[] split = adminIdArray.split(",");

            SelectorItemCollection sic = new SelectorItemCollection();
            sic.add("orderStatuc");
            Map isSortedMap = null;
            for (int i = 0; i < split.length; i++) {
                String adminId = split[i];
                ExamineGradePersonEntryCollection entryColl = getCurrentPersonEqualsScore(billID, adminId);
                //У˳
                isSortedMap = isSorted(entryColl);
                //÷
                saveScore(isSortedMap, entryColl);
            }
            //try {
            //    //ȡǰ¼˵˵
            //    ExamineGradePersonEntryCollection entrys = getCurrentPersonEqualsScore(billID, null);
            //    //ѯǷά֯Ч÷
            //    Map isSortedMap = isSorted(entrys);
            //    //for (int i = 0; entrys != null && i < entrys.size(); i++) {
            //    //    ExamineGradePersonEntryInfo entry = entrys.get(i);
            //    //    String depName = entry.getAdminOrg().getName();
            //    //    if (entry.getPerformanceScoreOrg() == null) {
            //    //        throw new ShrWebBizException("[" + depName + "]δά֯Ч÷!");
            //    //    }
            //    //}
            //    Map<String, Integer> maxNumberMap = (Map) isSortedMap.get("maxNumberMap");
            //    if (maxNumberMap != null) {
            //        //maxNumberMap
            //        for (String key : maxNumberMap.keySet()) {
            //            ExamineGradePersonEntryCollection entryColl = getCurrentPersonEqualsScore(billID, key);
            //            //У˳
            //            Map isSortedMap2 = isSorted(entryColl);
            //            //÷
            //            saveScore(isSortedMap2, entryColl);
            //        }
            //    }
            JSONUtils.SUCCESS(isSortedMap);
        } catch (SHRWebException | EASBizException e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        } catch (ParserException e) {
            throw new RuntimeException(e);
        }

    }

    ///**
    // * ÷
    // *
    // * @param map    key ID  Ͳŵȼ
    // * @param entrys
    // * @throws BOSException
    // * @throws EASBizException
    // */
    //private void saveScore(Map<String, Object> map,
    //                       ExamineGradePersonEntryCollection entrys)
    //        throws BOSException, EASBizException, ShrWebBizException {
    //    IExamineGradePersonEntry iExamineGradePersonEntry = ExamineGradePersonEntryFactory.getLocalInstance(ctx);
    //    IExamineGradePerson iExamineGradePerson = ExamineGradePersonFactory.getLocalInstance(ctx);
    //    Map<String, Integer> maxNumberMap = (Map) map.get("maxNumberMap");
    //    Map<String, String> adminGradeMap = (Map) map.get("adminGradeMap");
    //    if (maxNumberMap != null) {
    //        //maxNumberMap
    //        for (String key : maxNumberMap.keySet()) {
    //            //
    //            int depPersonNum = maxNumberMap.get(key);
    //            logger.debug("Key: " + key + ", Value: " + depPersonNum);
    //            //ȡ֯÷
    //            String adminOrgScore = adminGradeMap.get(key);
    //            //жǷB-
    //            Boolean isBMinus = false;
    //            //ȡ÷
    //            Map<String, List<String>> scoreLevelMap = getScoreLevelList(depPersonNum, adminOrgScore);
    //            for (int i = 0; i < entrys.size(); i++) {
    //                //޸ı÷
    //                saveExamineScorer(entrys, iExamineGradePersonEntry, key, i, scoreLevelMap);
    //            }
    //        }
    //    }
    //}

    /**
     * ÷
     *
     * @param map    key ID  Ͳŵȼ
     * @param entrys
     * @throws BOSException
     * @throws EASBizException
     */
    private void saveScore(Map<String, Object> map,
                           ExamineGradePersonEntryCollection entrys)
            throws BOSException, EASBizException, ShrWebBizException {
        IExamineGradePersonEntry iExamineGradePersonEntry = ExamineGradePersonEntryFactory.getLocalInstance(ctx);
        IExamineGradePerson iExamineGradePerson = ExamineGradePersonFactory.getLocalInstance(ctx);
        Map<String, Integer> maxNumberMap = (Map) map.get("maxNumberMap");
        Map<String, String> adminGradeMap = (Map) map.get("adminGradeMap");
        if (maxNumberMap != null) {
            //maxNumberMap
            for (String key : maxNumberMap.keySet()) {
                //
                int depPersonNum = maxNumberMap.get(key);
                logger.debug("Key: " + key + ", Value: " + depPersonNum);
                //ȡ֯÷
                String adminOrgScore = adminGradeMap.get(key);
                //жǷB-
                Boolean isBMinus = false;
                if (depPersonNum > 5) {
                    //ȡ÷
                    Map<String, List<String>> scoreLevelMap = getScoreLevelList(depPersonNum, adminOrgScore);
                    for (int i = 0; i < entrys.size(); i++) {
                        //޸ı÷
                        saveExamineScorer(entrys, iExamineGradePersonEntry, key, i, scoreLevelMap);

                    }
                } else {
                    //ȡ
                    ExamineGradePersonInfo examineGradePersonInfo =
                            iExamineGradePerson.getExamineGradePersonInfo("where id = '" + entrys.get(0).getParent().getId() + "'");
                    //жȵĻֱӼ
                    if (examineGradePersonInfo.getPeriodType() == periodTypeEnum.year) {
                        //ȡ÷
                        Map<String, List<String>> scoreLevelMap = getScoreLevelList(depPersonNum, adminOrgScore);
                        for (int i = 0; i < entrys.size(); i++) {
                            //޸ı÷
                            saveExamineScorer(entrys, iExamineGradePersonEntry, key, i, scoreLevelMap);
                        }
                    } else {
                        //жǷ1 1ֱӼ
                        if (examineGradePersonInfo.getQuarter() == 1) {
                            //ȡ÷
                            Map<String, List<String>> scoreLevelMap = getScoreLevelList(depPersonNum, adminOrgScore);
                            for (int i = 0; i < entrys.size(); i++) {
                                //޸ı÷
                                saveExamineScorer(entrys, iExamineGradePersonEntry, key, i, scoreLevelMap);
                            }
                        } else {

                            //¼϶ ۼϼȺͱ
                            ExamineGradePersonEntryCollection entryCollection = new ExamineGradePersonEntryCollection();
                            //5˵ó浽һµĶ
                            entryCollection = entrys;
                            //洢ǰ
                            ExamineGradePersonEntryCollection dqEntryCollection = new ExamineGradePersonEntryCollection();
                            for (int i = 0; i < entrys.size(); i++) {
                                dqEntryCollection.add(entrys.get(i));
                            }
                            //洢ϸȵĵ÷ֵȼ
                            List upList = new ArrayList();
                            //ѯϼȸòŵ
                            FilterInfo filterInfo = new FilterInfo();
                            FilterItemCollection filterItems = filterInfo.getFilterItems();
                            filterItems.add(new FilterItemInfo("parent.periodType", "2", CompareType.EQUALS));
                            filterItems.add(new FilterItemInfo("parent.year", examineGradePersonInfo.getYear()));
                            filterItems.add(new FilterItemInfo("adminOrg.id", key));
                            filterItems.add(new FilterItemInfo("parent.quarter", examineGradePersonInfo.getQuarter() - 1));
                            EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, null, null);
                            //ϸȼ
                            ExamineGradePersonEntryCollection upExamineGradePersonEntryColl = iExamineGradePersonEntry.getExamineGradePersonEntryCollection(entityViewInfo);
                            if (upExamineGradePersonEntryColl.size() > 0) {
                                //ExamineGradePersonInfo upExamineGradePersonInfo = upExamineGradePersonColl.get(0);
                                //for (int i = 0; i < upExamineGradePersonInfo.getEntrys().size(); i++) {
                                for (int i = 0; i < upExamineGradePersonEntryColl.size(); i++) {
                                    entryCollection.add(upExamineGradePersonEntryColl.get(i));
                                    switch (upExamineGradePersonEntryColl.get(i).getScoreLeader().toString()) {
                                        case "A":
                                            upList.add("1");
                                            break;
                                        case "B+":
                                            upList.add("2");
                                            break;
                                        case "B":
                                            upList.add("3");
                                            break;
                                        case "B-":
                                            upList.add("4");
                                            break;
                                        case "C":
                                            upList.add("5");
                                            break;
                                        case "D":
                                            upList.add("6");
                                            break;

                                    }
                                }

                                if (dqEntryCollection.size() == 5) {
                                    //upExamineGradePersonInfo ǰϸȲһ
                                    isBMinus = isNotExistBMinus(upExamineGradePersonEntryColl);
                                    //dqEntryCollectionǰ
                                    isBMinus = isNotExistBMinus(dqEntryCollection);
                                }
                            }


                            //޸ļ÷ֺ쵼÷
                            SelectorItemCollection sic = new SelectorItemCollection();
                            sic.add("score");
                            sic.add("scoreLeader");
                            sic.add("afterScoreNumMap");
                            //ȡ÷
                            Map<String, List<String>> scoreLevelMap = getScoreLevelList(entryCollection.size(), adminOrgScore);
                            for (int i = 0; i < dqEntryCollection.size(); i++) {
                                //saveExamineScorer(entrys, iExamineGradePersonEntry, key, i, scoreLevelMap);
                                ExamineGradePersonEntryInfo examineGradePersonEntryInfo =
                                        iExamineGradePersonEntry.getExamineGradePersonEntryInfo("select * ,performanceScoreOrg.* where id = '" + dqEntryCollection.get(i).getId().toString() + "'");
                                if (key.equals(examineGradePersonEntryInfo.getAdminOrg().getId().toString())) {
                                    //ȡ÷ּ
                                    String name = examineGradePersonEntryInfo.getPerformanceScoreOrg().getName();
                                    //ȡ˳
                                    int index = examineGradePersonEntryInfo.getIndex();
                                    List<String> listArray = scoreLevelMap.get(name);

                                    //ɾϸȵֵȼȡǰԱ÷ֵȼ
                                    subtractArrays(listArray, upList);
                                    //ԱǡõжϸǷB-ûⱾڱҪһB-
                                    if (dqEntryCollection.size() == 5 && !isBMinus) {
                                        listArray.set(listArray.size() - 1, "4");
                                    }
                                    //ͨ˳ŻȡlistArray  index-1Ӧ±
                                    String scoreLeavel = listArray.get(index - 1);

                                    //ۼƵ÷
                                    Map addupScore = new HashMap();
                                    getListArrayGradeNum(listArray, addupScore);


                                    //޸ĵ
                                    examineGradePersonEntryInfo.setScore(scoreEnum.getEnum(scoreLeavel));
                                    examineGradePersonEntryInfo.setScoreLeader(scoreEnum.getEnum(scoreLeavel));
                                    examineGradePersonEntryInfo.setAfterScoreNumMap(addupScore.toString());
                                    iExamineGradePersonEntry.updatePartial(examineGradePersonEntryInfo, sic);
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    /**
     * ȡϼȺ͵ǰȵĺ ȥǰȵĵȼ õľǵǰȵȼ͸ б
     *
     * @param listArray
     * @param addupScore
     */
    public void getListArrayGradeNum(List<String> listArray, Map addupScore) {
        Map<String, Integer> countMap = new HashMap<>();
        for (String num : listArray) {
            countMap.put(num, countMap.getOrDefault(num, 0) + 1);
        }

        // ͵ĸ
        for (Map.Entry<String, Integer> entry : countMap.entrySet()) {
            logger.debug(" " + entry.getKey() + "  " + entry.getValue() + " ");
            if (entry.getKey().equals("1")) {
                addupScore.put("A", entry.getValue());
            }
            if (entry.getKey().equals("2")) {
                addupScore.put("B+", entry.getValue());
            }
            if (entry.getKey().equals("3")) {
                addupScore.put("B", entry.getValue());
            }
            if (entry.getKey().equals("4")) {
                addupScore.put("B-", entry.getValue());
            }
            if (entry.getKey().equals("5")) {
                addupScore.put("C", entry.getValue());
            }
            if (entry.getKey().equals("6")) {
                addupScore.put("D", entry.getValue());
            }
        }
    }

    /**
     * жǷB-
     *
     * @return
     */
    public boolean isNotExistBMinus(ExamineGradePersonEntryCollection entryCollection) {
        //5ѭжϼȺͱǷB-
        for (int i = 0; i < entryCollection.size(); i++) {
            ExamineGradePersonEntryInfo examineGradePersonEntryInfo = entryCollection.get(i);
            if (examineGradePersonEntryInfo.getScore() != null) {
                if (examineGradePersonEntryInfo.getScore().equals("4")) {
                    return true;
                }
            }

        }
        return false;
    }

    /**
     * ύť֯F7
     *
     * @param request
     * @param response
     * @param modelMap
     */
    public void submitFilterAdminAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) {
        String billID = request.getParameter("billId");
        try {
            ExamineGradePersonEntryCollection entrys = getCurrentPersonEqualsScore(billID, null);
            Set set = new HashSet<>();
            StringBuilder sb = new StringBuilder();
            //ȥز
            for (int i = entrys.size() - 1; i >= 0; i--) {
                ExamineGradePersonEntryInfo examineGradePersonEntryInfo = entrys.get(i);
                String adminId = examineGradePersonEntryInfo.getAdminOrg().getId().toString();
                if (set.contains(adminId)) {
                    entrys.remove(examineGradePersonEntryInfo);
                } else {
                    set.add(adminId);
                    sb.append("'").append(adminId).append("',");
                }
            }
            // ɾһ
            if (sb.length() > 0) {
                sb.deleteCharAt(sb.length() - 1);
            }
            JSONUtils.SUCCESS(sb);
        } catch (ParserException e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        } catch (BOSException e) {
            throw new RuntimeException(e);
        } catch (SHRWebException e) {
            throw new RuntimeException(e);
        }
    }

    /**
     * ʵļ
     *
     * @param array1
     * @param array2
     */
    private static void subtractArrays(List<String> array1, List<String> array2) {
        try {
            // ʹõһ飬ȫɾ
            Iterator<String> iterator = array1.iterator();
            while (iterator.hasNext()) {
                String item = iterator.next();
                // ڶаǰԪأӵһƳ
                if (array2.contains(item)) {
                    iterator.remove();
                    // ӵڶƳԪأԱƳͬԪ
                    array2.remove(item);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * ޸ı÷
     *
     * @param entrys
     * @param iExamineGradePersonEntry
     * @param key
     * @param i
     * @param scoreLevelMap
     * @throws BOSException
     * @throws EASBizException
     */
    private void saveExamineScorer(ExamineGradePersonEntryCollection entrys, IExamineGradePersonEntry iExamineGradePersonEntry, String key, int i, Map<String, List<String>> scoreLevelMap) throws BOSException, EASBizException, ShrWebBizException {
        //޸ļ÷ֺ쵼÷
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("score");
        sic.add("scoreLeader");
        sic.add("afterScoreNumMap");
        ExamineGradePersonEntryInfo examineGradePersonEntryInfo =
                iExamineGradePersonEntry.getExamineGradePersonEntryInfo("select * ,performanceScoreOrg.* where id = '" + entrys.get(i).getId().toString() + "'");
        if (key.equals(examineGradePersonEntryInfo.getAdminOrg().getId().toString())) {
            //ȡ÷ּ
            String name = examineGradePersonEntryInfo.getPerformanceScoreOrg().getName();
            //ȡ˳
            int index = examineGradePersonEntryInfo.getIndex();
            List<String> listArray = scoreLevelMap.get(name);
            //ͨ˳ŻȡlistArray  index-1Ӧ
            String scoreLeavel = listArray.get(index - 1);
            //ȡ÷ֶӦ
            Map<String, Map<String, Integer>> numMap = (Map) scoreLevelMap.get("numMap");
            //ۼƵ÷
            Map addupScore = new HashMap();
            for (String numMapkey : numMap.keySet()) {
                Map<String, Integer> numMapValue = numMap.get(numMapkey);
                Integer numMapValue2 = null;
                for (String numMap2 : numMapValue.keySet()) {
                    numMapValue2 = numMapValue.get(numMap2);
                }
                addupScore.put(numMapkey, numMapValue2);

            }
            //޸ĵ
            examineGradePersonEntryInfo.setScore(scoreEnum.getEnum(scoreLeavel));
            if (examineGradePersonEntryInfo.getScoreLeader() == null) {
                examineGradePersonEntryInfo.setScoreLeader(scoreEnum.getEnum(scoreLeavel));
            }
            examineGradePersonEntryInfo.setAfterScoreNumMap(addupScore.toString());
            iExamineGradePersonEntry.updatePartial(examineGradePersonEntryInfo, sic);
        }
    }

    /**
     * ȡ÷ּ
     *
     * @param num       
     * @param scoreType ֯Ч÷ A B+ B B- C D
     */
    public Map getScoreLevelList(int num, String scoreType) {
        try {
            IPersonRelationOrg iPersonRelationOrg = PersonRelationOrgFactory.getLocalInstance(ctx);
            //֯Ч˼ЧֲӦϵ
            PersonRelationOrgCollection personRelationOrgCollection = iPersonRelationOrg.getPersonRelationOrgCollection();
            Map scoreLevelMap = new HashMap<>();
            //
            Map numMap = new HashMap<>();
            Map numMap2 = null;
            for (int i = 0; i < personRelationOrgCollection.size(); i++) {
                PersonRelationOrgInfo personRelationOrgInfo = personRelationOrgCollection.get(i);
                if (!personRelationOrgInfo.getName().equals(scoreType)) {
                    continue;
                }
                Integer ratioPerformanceA = personRelationOrgInfo.getMeritA();
                Integer ratioPerformanceBplus = personRelationOrgInfo.getMeritBplus();
                Integer ratioPerformanceB = personRelationOrgInfo.getMeritB();
                Integer ratioPerformanceBminus = personRelationOrgInfo.getMeritBminus();
                Integer ratioPerformanceC = personRelationOrgInfo.getMeritC();
                Integer ratioPerformanceD = personRelationOrgInfo.getMeritD();

                //㱣һλС  formatDecimalOneDecimalPlaceһλС
                //jsbfb ٷֱתΪС
                double a = formatDecimalOneDecimalPlace(jsbfb(ratioPerformanceA, num));
                double bPlus = formatDecimalOneDecimalPlace(jsbfb(ratioPerformanceBplus, num));
                double b = formatDecimalOneDecimalPlace(jsbfb(ratioPerformanceB, num));
                double bMinus = formatDecimalOneDecimalPlace(jsbfb(ratioPerformanceBminus, num));
                double c = formatDecimalOneDecimalPlace(jsbfb(ratioPerformanceC, num));
                double d = formatDecimalOneDecimalPlace(jsbfb(ratioPerformanceD, num));

                //ȥmapʲôӦʲôȼ
                Map<String, Double> map = new HashMap();
                map.put("A", a);
                map.put("B+", bPlus);
                map.put("B", b);
                map.put("B-", bMinus);
                map.put("C", c);
                map.put("D", d);
                System.out.println(map.toString());
                //Աȵݻȡȼȼ
                List<String> scoreGrade = new ArrayList();
                scoreGrade.add("A");
                scoreGrade.add("B+");
                scoreGrade.add("B");
                scoreGrade.add("B-");
                scoreGrade.add("C");
                scoreGrade.add("D");

                List<Map.Entry<String, Double>> list = new LinkedList<>(map.entrySet());

                Collections.sort(list, new Comparator<Map.Entry<String, Double>>() {
                    @Override
                    public int compare(Map.Entry<String, Double> o1, Map.Entry<String, Double> o2) {
                        // ȡСһλбȽ
                        double o1Value = extractDecimalDigit(o1.getValue());
                        double o2Value = extractDecimalDigit(o2.getValue());
                        return Integer.compare((int) o2Value, (int) o1Value);
                    }
                });
                logger.debug("ɾǰ" + list);
                // ɾֵΪ0
                Iterator<Map.Entry<String, Double>> iterator = list.iterator();
                while (iterator.hasNext()) {
                    Map.Entry<String, Double> entry = iterator.next();
                    if (entry.getValue() == 0) {
                        iterator.remove();
                    }
                }

                logger.debug("ɾ" + list);
                //洢ÿ÷ֵ磺{A=1, B=4, C=0, D=0, B+=2}
                Map<String, Integer> scoreMap = new HashMap();
                //Ƿ
                int personNum = 0;
                //ȡһݵ
                Map.Entry<String, Double> stringDoubleEntry = list.get(list.size() - 1);
                for (int q = 0; q < list.size(); q++) {
                    Map.Entry<String, Double> upMap = list.get(q);
                    if (q != list.size() - 1) {
                        Map.Entry<String, Double> pgMap = list.get(q + 1);
                        String upKey = upMap.getKey();
                        double upValue = extractDecimalDigit(upMap.getValue());
                        String pg = pgMap.getKey();
                        double pgValue = extractDecimalDigit(pgMap.getValue());
                        if (upValue >= pgValue) {
                            int upMapValue = (int) Math.round(upMap.getValue());
                            personNum += upMapValue;
                            //ۼĵȼ-1
                            if (personNum > num) {
                                scoreMap.put(upMap.getKey(), --upMapValue);
                            } else {
                                scoreMap.put(upMap.getKey(), upMapValue);
                            }
                        }
                    } else {
                        if (num > personNum) {
                            //һβ -Ѿֵ
                            scoreMap.put(upMap.getKey(), num - (personNum));
                        } else if (num == personNum) {
                            scoreMap.put(upMap.getKey(), 0);
                        } else {
                            scoreMap.put(upMap.getKey(), num - (--personNum));
                        }

                    }
                }

                List scoreLevelList = new ArrayList();
                System.out.println(scoreMap);
                for (String key : scoreMap.keySet()) {
                    //÷
                    Integer scorePersonNum = scoreMap.get(key);
                    if (key.equals("A")) {
                        getScoreLevel(scoreLevelList, scorePersonNum, "1");
                    }
                    if (key.equals("B+")) {
                        getScoreLevel(scoreLevelList, scorePersonNum, "2");
                    }
                    if (key.equals("B")) {
                        getScoreLevel(scoreLevelList, scorePersonNum, "3");
                    }
                    if (key.equals("B-")) {
                        getScoreLevel(scoreLevelList, scorePersonNum, "4");
                    }
                    if (key.equals("C")) {
                        getScoreLevel(scoreLevelList, scorePersonNum, "5");
                    }
                    if (key.equals("D")) {
                        getScoreLevel(scoreLevelList, scorePersonNum, "6");
                    }
                    numMap2 = new HashMap<>();
                    numMap2.put(key, scorePersonNum);
                    numMap.put(key, numMap2);
                }
                scoreLevelMap.put(personRelationOrgInfo.getName(), scoreLevelList);
                scoreLevelMap.put("numMap", numMap);
                List orderScore = (List) scoreLevelMap.get(personRelationOrgInfo.getName());
                orderScore.sort(null);
                logger.debug("scoreLevelMap:" + scoreLevelMap);
                return scoreLevelMap;
            }
        } catch (BOSException e) {
            throw new RuntimeException(e);
        }
        return null;
    }

    /**
     * ȡСһλ
     *
     * @param value
     * @return
     */
    private double extractDecimalDigit(double value) {
        return ((value * 10) % 10);
    }

    /**
     * ȡ÷ּ
     */
    public void getScoreLevel(List list, int num, String scoreLevel) {
        for (int i = 0; i < num; i++) {
            list.add(scoreLevel);
        }
    }

    /**
     * ȡһλС
     *
     * @param number
     * @return
     */
    public double formatDecimalOneDecimalPlace(double number) {
        // DecimalFormatָһλС
        DecimalFormat df = new DecimalFormat("#.0");

        // ʽ
        String formattedNumber = df.format(number);

        // ַתΪdouble
        double roundedNumber = Double.parseDouble(formattedNumber);
        return roundedNumber;
    }

    /**
     * ٷֱתΪС
     *
     * @param percentage
     * @param num2
     * @return
     */
    public double jsbfb(double percentage, Integer num2) {
        return percentage / 100 * num2; // ٷֱתΪС
    }

    /**
     * УǷ˳ظϲ,ͱ÷
     *
     * @param entrys
     * @return
     */
    private Map isSorted(ExamineGradePersonEntryCollection entrys) throws ShrWebBizException {

        List<ExamineGradePersonEntryInfo> list = new ArrayList<>();
        for (int i = 0; i < entrys.size(); i++) {
            ExamineGradePersonEntryInfo entry = entrys.get(i); // üṩgetȡԪ
            list.add(entry);
        }
        //list
        Collections.sort(list, new Comparator<ExamineGradePersonEntryInfo>() {
            @Override
            public int compare(ExamineGradePersonEntryInfo o1, ExamineGradePersonEntryInfo o2) {
                // Ȱ
                int nameComparison = o1.getAdminOrg().getId().toString().compareTo(o2.getAdminOrg().getId().toString());
                if (nameComparison != 0) {
                    return nameComparison;
                }
                // ͬձ
                return o1.getIndex() - o2.getIndex();
            }
        });
        Map<String, Object> map = new HashMap();
        // ʹMap洢ÿ
        Map<String, Integer> maxNumberMap = new HashMap<>();
        // ʹMap洢ÿĵ÷ֵȼ
        Map<String, String> adminGradeMap = new HashMap<>();
        // for (ExamineGradePersonEntryInfo entryInfo : list) {
        for (int i = 0; i < list.size(); i++) {
            ExamineGradePersonEntryInfo entryInfo = list.get(i);
            AdminOrgUnitInfo adminOrg = entryInfo.getAdminOrg();
            String adminId = adminOrg.getId().toString();
            int order = entryInfo.getIndex();
            String scoreGrade = entryInfo.getPerformanceScoreOrg().getName();
            Integer maxNumber = maxNumberMap.getOrDefault(adminId, 0);
            // Ƿ˳ûжϲ
            if (order == maxNumber + 1) {
                maxNumberMap.put(adminId, order);
                adminGradeMap.put(adminId, scoreGrade);
            } else {
                throw new ShrWebBizException("[" + adminOrg.getName() + "] е˳򲻷Ϲindex!!");
            }
        }
        map.put("maxNumberMap", maxNumberMap);
        map.put("adminGradeMap", adminGradeMap);
        return map;
    }

    /**
     * ȡǰ¼˵˵
     *
     * @param billID
     * @return
     */
    public ExamineGradePersonEntryCollection getCurrentPersonEqualsScore(String billID,
                                                                         String adminID) throws ParserException, BOSException {
        //ǰ¼Աid
        String currentPersonId = ContextUtil.getCurrentUserInfo(ctx).getPerson().getId().toString();
        SelectorItemCollection sic = new SelectorItemCollection();

        sic.add("*");
        sic.add("adminOrg.*");
        sic.add("performanceScoreOrg.*");
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        filterItems.add(new FilterItemInfo("parent.id", billID));
        filterItems.add(new FilterItemInfo("orderStatuc", "2", CompareType.NOTEQUALS));
        filterItems.add(new FilterItemInfo("scorer.id", currentPersonId));
        if (!com.kingdee.util.StringUtils.isEmpty(adminID)) {
            filterItems.add(new FilterItemInfo("adminOrg.id", adminID));
        }
        SorterItemCollection sorterItemCollection = new SorterItemCollection("adminOrg.id,index");
        EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, sic, sorterItemCollection);
        IExamineGradePersonEntry iExamineGradePersonEntry = ExamineGradePersonEntryFactory.getLocalInstance(ctx);
        return iExamineGradePersonEntry.getExamineGradePersonEntryCollection(entityViewInfo);
    }




    /**
     * ȡ˺ ҳһ
     *
     * @param entrys
     */
    private void getHheFilteredData(ExamineGradePersonEntryCollection entrys) {
        //ǰ¼Աid
        String currentPersonId = ContextUtil.getCurrentUserInfo(ctx).getPerson().getId().toString();
        for (int i = entrys.size() - 1; i >= 0; i--) {
            ExamineGradePersonEntryInfo examineGradePersonEntryInfo = entrys.get(i);
            //id
            String scorerId = examineGradePersonEntryInfo.getScorer().getId().toString();
            //
            orderStatucEnum orderStatus = examineGradePersonEntryInfo.getOrderStatuc();
            if (!currentPersonId.equals(scorerId)) {
                entrys.remove(examineGradePersonEntryInfo);
            }
        }
        //ʾ
        for (int i = entrys.size() - 1; i >= 0; i--) {
            ExamineGradePersonEntryInfo examineGradePersonEntryInfo = entrys.get(i);
            //
            orderStatucEnum orderStatus = examineGradePersonEntryInfo.getOrderStatuc();
            if (orderStatus == null || !orderStatus.equals(orderStatucEnum.startOrder)) {
                entrys.remove(examineGradePersonEntryInfo);
            }
        }
    }

    /**
     * ȡֵ   ༭ ʾǰ¼
     *
     * @param request
     * @param modelID id
     * @return
     * @throws SHRWebException
     */
    @Override
    protected CoreBaseInfo getValue(HttpServletRequest request, String modelID) throws SHRWebException {
        ExamineGradePersonInfo examineGradePersonInfo = (ExamineGradePersonInfo) super.getValue(request, modelID);
        ExamineGradePersonEntryCollection entrys = examineGradePersonInfo.getEntrys();
        //ǰ¼Աid
        String currentPersonId = ContextUtil.getCurrentUserInfo(ctx).getPerson().getId().toString();
        for (int i = entrys.size() - 1; i >= 0; i--) {
            ExamineGradePersonEntryInfo examineGradePersonEntryInfo = entrys.get(i);
            //id
            String scorerId = examineGradePersonEntryInfo.getScorer().getId().toString();
            //
            if (!currentPersonId.equals(scorerId)) {
                entrys.remove(examineGradePersonEntryInfo);
            }
        }
        //ʾ
        for (int i = entrys.size() - 1; i >= 0; i--) {
            ExamineGradePersonEntryInfo examineGradePersonEntryInfo = entrys.get(i);
            //
            orderStatucEnum orderStatus = examineGradePersonEntryInfo.getOrderStatuc();
            if (orderStatus == null || orderStatus.equals(orderStatucEnum.closeOrder)) {
                entrys.remove(examineGradePersonEntryInfo);
            }
        }
        return examineGradePersonInfo;
    }
    //

    /**
     *  ҳ治Ҫ ֻ޸
     *
     * @param request
     * @param response
     * @param modelMap
     * @return
     * @throws SHRWebException
     */
    @Override
    public String saveAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        ExamineGradePersonInfo model = (ExamineGradePersonInfo) request.getAttribute("dynamic_model");
        try {
            ExamineGradePersonEntryCollection entrys = model.getEntrys();
            IExamineGradePersonEntry iExamineGradePersonEntry = ExamineGradePersonEntryFactory.getLocalInstance(ctx);
            for (int i = 0; i < entrys.size(); i++) {
                ExamineGradePersonEntryInfo examineGradePersonEntryInfo = entrys.get(i);
                iExamineGradePersonEntry.update(new ObjectUuidPK(examineGradePersonEntryInfo.getId().toString()), examineGradePersonEntryInfo);
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        }
        return null;
    }

    /**
     * УǷ
     *
     * @param request
     * @param response
     * @param modelMap
     */
    public void isValidationPeriodExpiredAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws ShrWebBizException {
        String billID = request.getParameter("billId");
        if (com.kingdee.util.StringUtils.isEmpty(billID)) {
            throw new ShrWebBizException("УǷϵԱ");
        }
        try {
            IExamineGradePerson iExamineGradePerson = ExamineGradePersonFactory.getLocalInstance(ctx);
            JSONUtils.SUCCESS(iExamineGradePerson.getExamineGradePersonInfo(new ObjectUuidPK(billID)).getPeriodStatus());
        } catch (BOSException e) {
            e.printStackTrace();
            throw new ShrWebBizException(e);
        } catch (SHRWebException e) {
            e.printStackTrace();
            throw new ShrWebBizException(e);
        } catch (EASBizException e) {
            e.printStackTrace();
            throw new ShrWebBizException(e);
        }
    }

}
