package com.kingdee.eas.custom.performancenew.handler;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.ctrl.swing.StringUtils;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.eas.basedata.org.AdminOrgUnitFactory;
import com.kingdee.eas.basedata.org.AdminOrgUnitInfo;
import com.kingdee.eas.custom.performancenew.*;
import com.kingdee.eas.custom.performancenew.app.orderStatucEnum;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.util.app.ContextUtil;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.web.handler.EditHandler;
import com.kingdee.shr.base.syssetting.web.json.JSONUtils;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.*;

/**
 * @author qingwu
 * @date 2024/4/11
 * @apiNote ڼ  ͨ
 */
public class ExamineScorerEditHandlerBiz extends EditHandler {
    private Context ctx = SHRContext.getInstance().getContext();

    public void calculateScoreAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws BOSException {
        String billID = request.getParameter("billId");
        if (StringUtils.isEmpty(billID)) {
            throw new BOSException("idΪգ");
        }
        IExamineGradePerson iExamineGradePerson = ExamineGradePersonFactory.getLocalInstance(ctx);
        try {
            Map isSortedMap = isSorted(iExamineGradePerson, billID);
            JSONUtils.SUCCESS(isSortedMap);
        } catch (SHRWebException e) {
            throw new RuntimeException(e);
        }

    }

    /**
     * УǷ˳ظϲ
     *
     * @param iExamineGradePerson
     * @param billID
     * @return
     */
    private Map isSorted(IExamineGradePerson iExamineGradePerson, String billID) {
        Map map = new HashMap();
        try {
            ExamineGradePersonInfo examineGradePersonInfo = iExamineGradePerson.getExamineGradePersonInfo(new ObjectUuidPK(billID));
            ExamineGradePersonEntryCollection entrys = examineGradePersonInfo.getEntrys();
            getHheFilteredData(entrys);
            //
            List<ExamineGradePersonEntryInfo> list = new ArrayList<>();
            for (int i = 0; i < entrys.size(); i++) {
                ExamineGradePersonEntryInfo entry = entrys.get(i); // üṩgetȡԪ
                list.add(entry);
            }
            //list
            Collections.sort(list, new Comparator<ExamineGradePersonEntryInfo>() {
                @Override
                public int compare(ExamineGradePersonEntryInfo o1, ExamineGradePersonEntryInfo o2) {
                    // Ȱ
                    int nameComparison = o1.getAdminOrg().getId().toString().compareTo(o2.getAdminOrg().getId().toString());
                    if (nameComparison != 0) {
                        return nameComparison;
                    }
                    // ͬձ
                    return o1.getIndex() - o2.getIndex();
                }
            });

            // ʹMap洢ÿ
            Map<String, Integer> maxNumberMap = new HashMap<>();

            for (ExamineGradePersonEntryInfo entryInfo : list) {
                String adminId = entryInfo.getAdminOrg().getId().toString();
                int order = entryInfo.getIndex();
                Integer maxNumber = maxNumberMap.getOrDefault(adminId, 0);

                // Ƿ˳ûжϲ
                if (order == maxNumber + 1) {
                    maxNumberMap.put(adminId, order);
                } else {
                    AdminOrgUnitInfo adminOrgUnitInfo = AdminOrgUnitFactory.getLocalInstance(ctx).getAdminOrgUnitCollection("where id = '" + adminId + "'").get(0);
                    System.out.println(" " + adminOrgUnitInfo.getName() + " еıŲǰ˳Ļжϲ㣡");
                    map.put("is", false);
                    map.put("msg", " " + adminOrgUnitInfo.getName() + " еıŲǰ˳Ļжϲ㣡");
                    return map;
                }
            }

            map.put("is", true);
            return map;
            ////֮У˳Ƿнȡϲ߲ű
            //return isSortedByNumberAndOrder(list);
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        }
    }

    //public static boolean isSortedByNumberAndOrder(List<ExamineGradePersonEntryInfo> list) {
    //    Map<String, List<ExamineGradePersonEntryInfo>> groupedByID = new HashMap<>();
    //
    //    // Ʒ
    //    for (ExamineGradePersonEntryInfo entryInfo : list) {
    //        String adminID = entryInfo.getAdminOrg().getId().toString();
    //        if (!groupedByID.containsKey(adminID)) {
    //            groupedByID.put(adminID, new ArrayList<>());
    //        }
    //        groupedByID.get(adminID).add(entryInfo);
    //    }
    //
    //    // ÿƵ
    //    for (List<ExamineGradePersonEntryInfo> group : groupedByID.values()) {
    //        if (!isNumberSequential(group)) {
    //            return false;
    //        }
    //    }
    //
    //    return true;
    //}
    //
    //public static boolean isNumberSequential(List<ExamineGradePersonEntryInfo> group) {
    //    for (int i = 0; i < group.size() - 1; i++) {
    //        ExamineGradePersonEntryInfo examineGradePersonEntryInfo = group.get(i);
    //        int currentNumber = group.get(i).getOrder();
    //        int nextNumber = group.get(i + 1).getOrder();
    //
    //        // Ų˳лߴڶϲ㣬򷵻false
    //        if (currentNumber != nextNumber - 1) {
    //            return false;
    //        }
    //    }
    //    return true;
    //}

    /**
     * ȡ˺ ҳһ
     *
     * @param entrys
     */
    private void getHheFilteredData(ExamineGradePersonEntryCollection entrys) {
        //ǰ¼Աid
        String currentPersonId = ContextUtil.getCurrentUserInfo(ctx).getPerson().getId().toString();
        for (int i = entrys.size() - 1; i >= 0; i--) {
            ExamineGradePersonEntryInfo examineGradePersonEntryInfo = entrys.get(i);
            //id
            String scorerId = examineGradePersonEntryInfo.getScorer().getId().toString();
            //
            orderStatucEnum orderStatus = examineGradePersonEntryInfo.getOrderStatuc();
            if (!currentPersonId.equals(scorerId)) {
                entrys.remove(examineGradePersonEntryInfo);
            }
        }
        //ʾ
        for (int i = entrys.size() - 1; i >= 0; i--) {
            ExamineGradePersonEntryInfo examineGradePersonEntryInfo = entrys.get(i);
            //
            orderStatucEnum orderStatus = examineGradePersonEntryInfo.getOrderStatuc();
            if (orderStatus == null || !orderStatus.equals(orderStatucEnum.startOrder)) {
                entrys.remove(examineGradePersonEntryInfo);
            }
        }
    }

    /**
     * ȡֵ   ༭ ʾǰ¼
     *
     * @param request
     * @param modelID id
     * @return
     * @throws SHRWebException
     */
    @Override
    protected CoreBaseInfo getValue(HttpServletRequest request, String modelID) throws SHRWebException {
        ExamineGradePersonInfo examineGradePersonInfo = (ExamineGradePersonInfo) super.getValue(request, modelID);
        ExamineGradePersonEntryCollection entrys = examineGradePersonInfo.getEntrys();
        //ǰ¼Աid
        String currentPersonId = ContextUtil.getCurrentUserInfo(ctx).getPerson().getId().toString();
        for (int i = entrys.size() - 1; i >= 0; i--) {
            ExamineGradePersonEntryInfo examineGradePersonEntryInfo = entrys.get(i);
            //id
            String scorerId = examineGradePersonEntryInfo.getScorer().getId().toString();
            //
            if (!currentPersonId.equals(scorerId)) {
                entrys.remove(examineGradePersonEntryInfo);
            }
        }
        //ʾ
        for (int i = entrys.size() - 1; i >= 0; i--) {
            ExamineGradePersonEntryInfo examineGradePersonEntryInfo = entrys.get(i);
            //
            orderStatucEnum orderStatus = examineGradePersonEntryInfo.getOrderStatuc();
            if (orderStatus == null || !orderStatus.equals(orderStatucEnum.startOrder)) {
                entrys.remove(examineGradePersonEntryInfo);
            }
        }
        return examineGradePersonInfo;
    }
    //

    /**
     *  ҳ治Ҫ ֻ޸
     *
     * @param request
     * @param response
     * @param modelMap
     * @return
     * @throws SHRWebException
     */
    @Override
    public String saveAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        ExamineGradePersonInfo model = (ExamineGradePersonInfo) request.getAttribute("dynamic_model");
        try {
            ExamineGradePersonEntryCollection entrys = model.getEntrys();
            IExamineGradePersonEntry iExamineGradePersonEntry = ExamineGradePersonEntryFactory.getLocalInstance(ctx);
            for (int i = 0; i < entrys.size(); i++) {
                ExamineGradePersonEntryInfo examineGradePersonEntryInfo = entrys.get(i);
                iExamineGradePersonEntry.update(new ObjectUuidPK(examineGradePersonEntryInfo.getId().toString()), examineGradePersonEntryInfo);
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        }
        return null;
    }
}
