package com.kingdee.eas.custom.performancenew.handler;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.bos.sql.ParserException;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.performancenew.*;

import com.kingdee.eas.custom.performancenew.app.orderStatucEnum;
import com.kingdee.eas.custom.projectbonus.web.vo.*;
import com.kingdee.eas.hr.ats.AtsUtil;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.json.GridDataEntity;
import com.kingdee.shr.base.syssetting.web.handler.DynamicListHandler;
import com.kingdee.shr.base.syssetting.web.json.JSONUtils;
import com.kingdee.util.StringUtils;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author qingwu
 * @date 2024/4/10
 * @apiNote Ч  רԱά˺ҳ רԱ
 * EmpBatchEnrollListHandler
 */
public class ExamineZYDynamicListHandler extends DynamicListHandler {

    private Context ctx = SHRContext.getInstance().getContext();

    /**
     * customDelete  ɾ
     *
     * @param request
     * @param response
     * @param modelMap
     * @return
     * @throws SHRWebException
     */
    public void customDeleteAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException, BOSException, EASBizException {
        //ȡɾID
        String idArray = request.getParameter("idArray");
        IExamineGradePersonEntry iExamineGradePersonEntry = ExamineGradePersonEntryFactory.getLocalInstance(ctx);
        FilterInfo filterInfo = new FilterInfo();
        filterInfo.getFilterItems().add(new FilterItemInfo("id", AtsUtil.toSet(idArray), CompareType.INCLUDE));
        EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, null, null);
        ExamineGradePersonEntryCollection examineGradePersonEntryCollection = iExamineGradePersonEntry.getExamineGradePersonEntryCollection(entityViewInfo);
        if (examineGradePersonEntryCollection.size() > 0) {
            for (int i = 0; i < examineGradePersonEntryCollection.size(); i++) {
                ExamineGradePersonEntryInfo examineGradePersonEntryInfo = examineGradePersonEntryCollection.get(i);
                if (examineGradePersonEntryInfo.getOrderStatuc() == (orderStatucEnum.submitted) ||
                        examineGradePersonEntryInfo.getOrderStatuc() == (orderStatucEnum.startOrder)) {
                    throw new ShrWebBizException("ֻɾδݣ");
                }
            }
        }
        iExamineGradePersonEntry.delete(filterInfo);
    }

    /**
     * ȡЧڹ
     * Ƴ෽
     *
     * @param effectDate
     * @return
     */
    protected FilterInfo getEffectDateFilter(Date effectDate) {
        return null;
    }

    @Override
    protected void afterGetListData(HttpServletRequest request, HttpServletResponse response, GridDataEntity gridDataEntity) throws SHRWebException {
        List<Map<String, Object>> rows = gridDataEntity.getRows();
        //װF7Ŷ
        for (int i = 0; i < rows.size(); i++) {
            Map<String, Object> map = rows.get(i);
            Map<String, Object> colNameMap = null;
            //
            Object adminOrgID = map.get("adminorg.id");
            if (adminOrgID != null && !StringUtils.isEmpty(adminOrgID.toString())) {
                colNameMap = new HashMap<String, Object>();
                colNameMap.put("id", adminOrgID.toString());
                colNameMap.put("name", map.get("adminorg.name"));
                //
                map.put("adminorg.name", colNameMap);
            }
            //
            Object auditorId = map.get("auditor.id");
            if (auditorId != null && !StringUtils.isEmpty(auditorId.toString())) {
                colNameMap = new HashMap<String, Object>();
                colNameMap.put("id", auditorId.toString());
                colNameMap.put("name", map.get("auditor.name"));
                map.put("auditor.name", colNameMap);
            }
            //
            Object scorerId = map.get("scorer.id");
            if (scorerId != null && !StringUtils.isEmpty(scorerId.toString())) {
                colNameMap = new HashMap<String, Object>();
                colNameMap.put("id", scorerId.toString());
                colNameMap.put("name", map.get("scorer.name"));
                //
                map.put("scorer.name", colNameMap);
            }
        }
    }

    /**
     * ȡĬϱ༭
     *
     * @param request
     * @return
     */
    protected Map<String, Map<String, Object>> getDefultEditColumnsSetting(HttpServletRequest request) {
        try {
            Map<String, Map<String, Object>> result = new HashMap();
            //
            EditColumnInfo editColumnAuditorInfo4 = new EditColumnInfo();
            editColumnAuditorInfo4.setName("adminorg.name");
            //
            editColumnAuditorInfo4.setRequired(true);
            EditOptions editoptions4 = editColumnAuditorInfo4.getEditoptions();
            F7Json f7Json4 = editoptions4.getF7Json();
            SubWidgetOptions subWidgetOptions4 = f7Json4.getSubWidgetOptions();
            subWidgetOptions4.setUipk("shr.AllAdminOrgUnit.F7");
            subWidgetOptions4.setTitle("ѡ");
            subWidgetOptions4.setQuery("");
            result.put("adminorg.name", editColumnAuditorInfo4.convertToMap());
            //
            EditColumnInfo editColumnAuditorInfo2 = new EditColumnInfo();
            //
            editColumnAuditorInfo2.setRequired(true);
            editColumnAuditorInfo2.setName("auditor.name");
            EditOptions editoptions2 = editColumnAuditorInfo2.getEditoptions();
            F7Json f7Json2 = editoptions2.getF7Json();
            SubWidgetOptions subWidgetOptions2 = f7Json2.getSubWidgetOptions();
            subWidgetOptions2.setUipk("com.kingdee.eas.basedata.person.app.PersonQwEx.F7");
            subWidgetOptions2.setTitle("ѡ񿼺");
            //subWidgetOptions2.setQuery("com.kingdee.eas.hr.emp.emp_page.QwCostomPersonQuery");
            subWidgetOptions2.setQuery("com.kingdee.eas.hr.emp.app.PersonWebListQuery");
            result.put("auditor.name", editColumnAuditorInfo2.convertToMap());
            //
            EditColumnInfo editColumnAuditorInfo3 = new EditColumnInfo();
            //
            editColumnAuditorInfo3.setRequired(true);
            editColumnAuditorInfo3.setName("scorer.name");
            EditOptions editoptions3 = editColumnAuditorInfo3.getEditoptions();
            F7Json f7Json3 = editoptions3.getF7Json();
            SubWidgetOptions subWidgetOptions3 = f7Json3.getSubWidgetOptions();
            subWidgetOptions3.setUipk("com.kingdee.eas.basedata.person.app.PersonQwEx.F7");
            subWidgetOptions3.setTitle("ѡ");
            //subWidgetOptions3.setQuery("com.kingdee.eas.hr.emp.emp_page.QwCostomPersonQuery");
            subWidgetOptions3.setQuery("com.kingdee.eas.hr.emp.app.PersonWebListQuery");
            result.put("scorer.name", editColumnAuditorInfo3.convertToMap());
            //״̬ö
            EditColumnInfo stateEditColumn = new EditColumnInfo();
            stateEditColumn.setName("entrys.scoreLeader");
            stateEditColumn.setFormatter("shrselect");
            stateEditColumn.setEdittype("shrselect");
            stateEditColumn.setType("shrselect");
            EditOptions stateEditoptions = stateEditColumn.getEditoptions();
            stateEditoptions.setUrlSource("com.kingdee.eas.custom.performancenew.app.scoreEnum");
            SelectJson selectJson = stateEditoptions.getSelectJson();
            selectJson.setId("setScoreLeader");//
            selectJson.setName("scoreLeader");//
            selectJson.setEnumSource("com.kingdee.eas.custom.performancenew.app.scoreEnum");
            result.put("entrys.scoreLeader", stateEditColumn.convertToMap());
            return result;
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        }
    }

    /**
     * ̬
     *
     * @param request
     * @param response
     * @param modelMap
     * @throws SHRWebException
     * @returnA
     */
    public void saveDynGridAction(HttpServletRequest request,
                                  HttpServletResponse response,
                                  ModelMap modelMap) throws SHRWebException {
        Context ctx = SHRContext.getInstance().getContext();
        try {
            List<Map<String, String>> dataList = (List) JSONUtils.convertJsonToObject(request.getParameter("modi"), List.class);
            IExamineGradePersonEntry iExamineGradePersonEntry = ExamineGradePersonEntryFactory.getLocalInstance(ctx);
            //ݼ
            Map<String, ExamineGradePersonEntryInfo> updEntryCols = new HashMap<String, ExamineGradePersonEntryInfo>();
            //ֶ
            Map<String, SelectorItemCollection> updSics = new HashMap<String, SelectorItemCollection>();
            for (int i = 0; i < dataList.size(); i++) {
                Map<String, String> map = dataList.get(i);
                ExamineGradePersonEntryInfo entryInfo;
                SelectorItemCollection updSic;
                String fid = map.get("fid");
                //޸
                if (updEntryCols.containsKey(fid)) {
                    entryInfo = updEntryCols.get(fid);
                } else {
                    entryInfo = new ExamineGradePersonEntryInfo();
                    entryInfo.setId(BOSUuid.read(fid));
                    updEntryCols.put(fid, entryInfo);
                }
                //޸ֶ
                if (updSics.containsKey(fid)) {
                    updSic = updSics.get(fid);
                } else {
                    updSic = new SelectorItemCollection();
                    updSics.put(fid, updSic);
                }
                //ֶ
                String colName = map.get("column");

                //޸ֵ
                String value = map.get("value");
                //ֵ
                String type = map.get("type");
                updSic.add(colName);
                entryInfo.put(colName, value);
            }
            for (String id : updEntryCols.keySet()) {
                //޸ĵʵ
                ExamineGradePersonEntryInfo entryInfo = updEntryCols.get(id);
                //޸ĵֶ
                SelectorItemCollection updSic = updSics.get(id);
                iExamineGradePersonEntry.updatePartial(entryInfo, updSic);
            }
            JSONUtils.SUCCESS("ɹ޸" + dataList.size() + "");
        } catch (Exception e) {
            e.printStackTrace();
            throw new ShrWebBizException(e);
        }

    }

    @Override
    protected FilterInfo assembleFilterInfo(HttpServletRequest request, Map<String, String> params,
                                            Map filterCondition, Date effectDate) throws SHRWebException {
        FilterInfo filterInfo = super.assembleFilterInfo(request, params, filterCondition, effectDate);
        try {

            String custom_params = request.getParameter("custom_params");
            if (!StringUtils.isEmpty(custom_params)) {
                FilterInfo customFilter = new FilterInfo();
                Map customParams = JSONUtils.convertJsonToObject(custom_params);
                String examineGradePersonId = (String) customParams.get("examineGradePersonId");
                customFilter.getFilterItems().add(new FilterItemInfo("periodicQuarter.id", examineGradePersonId));
                customFilter.getFilterItems().add(new FilterItemInfo("entrys.id", null, CompareType.NOTEQUALS));
                filterInfo.mergeFilter(customFilter, "AND");
            }
            return filterInfo;
        } catch (BOSException e) {
            e.printStackTrace();
            throw new SHRWebException(e);
        }
    }

    /**
     * 
     *
     * @param request
     * @param response
     * @param modelMap
     */
    public void periodLockAction(HttpServletRequest request,
                                 HttpServletResponse response,
                                 ModelMap modelMap) throws BOSException, EASBizException, ShrWebBizException {
        try {
            String billId = request.getParameter("billId");
            ExamineGradePersonEntryCollection entrys = getCurrentPersonEqualsScore(billId, null);
            for (int i = 0; entrys != null && i < entrys.size(); i++) {
                ExamineGradePersonEntryInfo entry = entrys.get(i);
                if (entry.getOrderStatuc() != orderStatucEnum.submitted) {
                    throw new ShrWebBizException(entry.getAdminOrg().getName()+"["+entry.getAuditor().getName()+"] ״̬Ϊδύڣ");
                }
            }
            ExamineGradePersonFactory.getLocalInstance(ctx).periodLock(billId);
        } catch (BOSException e) {
            e.printStackTrace();
            throw new ShrWebBizException(e.getMessage());
        } catch (ParserException e) {
            throw new RuntimeException(e);
        }
    }

    /**
     * 
     *
     * @param request
     * @param response
     * @param modelMap
     */
    public void periodUnlockAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws EASBizException, ShrWebBizException {
        try {
            String billId = request.getParameter("billId");
            ExamineGradePersonFactory.getLocalInstance(ctx).periodUnlock(billId);
        } catch (BOSException e) {
            throw new ShrWebBizException(e.getMessage());
        }
    }

    /**
     * 
     */
    public void closeOrderAction(HttpServletRequest request,
                                 HttpServletResponse response,
                                 ModelMap modelMap) throws ShrWebBizException {
        String entryId = request.getParameter("entryId");
        try {
            if (StringUtils.isEmpty(entryId)) {
                throw new ShrWebBizException("빴ѡҪõݣ");
            }
            ExamineGradePersonFactory.getLocalInstance(ctx).closeOrder(entryId);
        } catch (BOSException e) {
            e.printStackTrace();
            throw new ShrWebBizException(e);
        }
    }

    /**
     * 
     */
    public void startOrderAction(HttpServletRequest request,
                                 HttpServletResponse response,
                                 ModelMap modelMap) throws SHRWebException {
        try {
            String billId = request.getParameter("billId");
            ExamineGradePersonEntryCollection entrys = getCurrentPersonEqualsScore(billId, null);
            for (int i = 0; entrys != null && i < entrys.size(); i++) {
                ExamineGradePersonEntryInfo entry = entrys.get(i);
                if(entry.getAdminOrg()==null||entry.getAuditor()==null||entry.getScorer()==null){
                    throw new ShrWebBizException("[//]ݲΪգ!!");
                }
                String depName = entry.getAdminOrg().getName();
                if (entry.getPerformanceScoreOrg() == null) {
                    throw new ShrWebBizException("[" + depName + "] ûά֯Ч÷!");
                }
            }
            ExamineGradePersonFactory.getLocalInstance(ctx).startOrder(billId);
        } catch (BOSException | ParserException e) {
            throw new ShrWebBizException(e.getMessage());
        }
    }

    /**
     * ȡ¼
     *
     * @param billID
     * @return
     */
    public ExamineGradePersonEntryCollection getCurrentPersonEqualsScore(String billID,
                                                                         String adminID) throws ParserException, BOSException {

        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("*");
        sic.add("adminOrg.*");
        sic.add("auditor.*");
        sic.add("performanceScoreOrg.*");
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        filterItems.add(new FilterItemInfo("parent.id", billID));
        if (!StringUtils.isEmpty(adminID)) {
            filterItems.add(new FilterItemInfo("adminOrg.id", adminID));
        }
        SorterItemCollection sorterItemCollection = new SorterItemCollection("adminOrg.id,index");
        EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, sic, sorterItemCollection);
        IExamineGradePersonEntry iExamineGradePersonEntry = ExamineGradePersonEntryFactory.getLocalInstance(ctx);
        return iExamineGradePersonEntry.getExamineGradePersonEntryCollection(entityViewInfo);
    }

}
